#ifdef __cplusplus
extern "C" { 
#endif

#ifndef __HROOT_TREE__TChain__
#define __HROOT_TREE__TChain__

#include "HROOT-treeType.h"
#include "HROOTTreeTTree.h"
#include "HROOTCoreTNamed.h"
#include "HROOTCoreTAttLine.h"
#include "HROOTCoreTAttFill.h"
#include "HROOTCoreTAttMarker.h"
#include "HROOTCoreTObject.h"
#include "HROOTCoreDeletable.h"

#undef TCHAIN_DECL_VIRT 
#define TCHAIN_DECL_VIRT(Type) \
int Type ## _addChain ( Type ## _p p, TChain_p chain ); \
int Type ## _addChain1 ( Type ## _p p, const char* name, signed long nentries )

#undef TCHAIN_DECL_NONVIRT 
#define TCHAIN_DECL_NONVIRT(Type) \
Type ## _p Type ## _newTChain ( const char* name, const char* title )

#undef TCHAIN_DEF_VIRT
#define TCHAIN_DEF_VIRT(Type)\
int Type ## _addChain ( Type ## _p p, TChain_p chain )\
{\
return TYPECASTMETHOD(Type,addChain,TChain)(p)->Add(to_nonconst<TChain,TChain_t>(chain));\
}\
int Type ## _addChain1 ( Type ## _p p, const char* name, signed long nentries )\
{\
return TYPECASTMETHOD(Type,addChain1,TChain)(p)->Add(name, nentries);\
}

#undef TCHAIN_DEF_NONVIRT
#define TCHAIN_DEF_NONVIRT(Type)\
Type ## _p Type ## _newTChain ( const char* name, const char* title )\
{\
Type * newp = new Type (name, title); \
return to_nonconst<Type ## _t, Type >(newp);\
}

TTREE_DECL_VIRT(TChain);
TNAMED_DECL_VIRT(TChain);
TATTLINE_DECL_VIRT(TChain);
TATTFILL_DECL_VIRT(TChain);
TATTMARKER_DECL_VIRT(TChain);
TOBJECT_DECL_VIRT(TChain);
DELETABLE_DECL_VIRT(TChain);


TCHAIN_DECL_VIRT(TChain);


TCHAIN_DECL_NONVIRT(TChain);


#endif // __HROOT_TREE__TChain__

#ifdef __cplusplus
}
#endif

